PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Friends | List of all members
PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt > Class Template Referenceabstract

`#include <bitwise_enum.h>`

Inheritance diagram for PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >:
[legend]
Collaboration diagram for PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >:
[legend]

## Public Types
typedef PBitwiseEnum< BaseEnum, MaxValue, BaseInt > | BaseClass
Public Types inherited from PBitwiseEnum< BaseEnum, MaxValue, BaseInt >
enum | IteratorBounds { First, Last }
typedef BaseEnum | Enumeration
typedef BaseInt | IntType

## Public Member Functions
__inline | PStreamableBitwiseEnum (typename BaseClass::Enumeration e=BaseClass::Zero())
__inline | PStreamableBitwiseEnum (typename BaseClass::IteratorBounds b)
virtual __inline | ~PStreamableBitwiseEnum ()
PString | ToString ()
bool | FromString (const PString &s, bool clear=true)
virtual char const *const * | Names () const =0
Public Member Functions inherited from PBitwiseEnum< BaseEnum, MaxValue, BaseInt >
__inline | PBitwiseEnum (Enumeration e=Zero())
__inline | PBitwiseEnum (const PBitwiseEnum &e)
__inline | PBitwiseEnum (IteratorBounds b)
__inline PBitwiseEnum & | operator= (const PBitwiseEnum &e)
__inline PBitwiseEnum & | operator= (Enumeration e)
__inline | operator Enumeration () const
__inline | operator Enumeration & ()
__inline | operator const Enumeration & () const
__inline Enumeration * | operator& ()
__inline unsigned | AsBits () const
PBitwiseEnum | operator++ ()
PBitwiseEnum | operator++ (int)
PBitwiseEnum | operator-- ()
PBitwiseEnum | operator-- (int)
__inline PBitwiseEnum & | operator|= (Enumeration rhs)
__inline PBitwiseEnum & | operator+= (Enumeration rhs)
__inline PBitwiseEnum & | operator-= (Enumeration rhs)
__inline PBitwiseEnum & | operator^= (Enumeration rhs)
__inline PBitwiseEnum | operator+ (Enumeration rhs) const
__inline PBitwiseEnum | operator| (Enumeration rhs) const
__inline PBitwiseEnum | operator- (Enumeration rhs) const
__inline PBitwiseEnum | operator^ (Enumeration rhs) const
__inline bool | operator& (Enumeration rhs) const
__inline bool | operator== (Enumeration rhs) const
__inline bool | operator<= (Enumeration rhs) const
__inline bool | operator>= (Enumeration rhs) const
__inline bool | operator!= (Enumeration rhs) const
__inline bool | operator< (Enumeration rhs) const
__inline bool | operator> (Enumeration rhs) const
__inline PBitwiseEnum & | operator|= (PBitwiseEnum rhs)
__inline PBitwiseEnum & | operator+= (PBitwiseEnum rhs)
__inline PBitwiseEnum & | operator-= (PBitwiseEnum rhs)
__inline PBitwiseEnum & | operator^= (PBitwiseEnum rhs)
__inline PBitwiseEnum | operator| (PBitwiseEnum rhs) const
__inline PBitwiseEnum | operator+ (PBitwiseEnum rhs) const
__inline PBitwiseEnum | operator- (PBitwiseEnum rhs) const
__inline PBitwiseEnum | operator^ (PBitwiseEnum rhs) const
__inline bool | operator& (PBitwiseEnum rhs) const
__inline bool | operator== (PBitwiseEnum rhs) const
__inline bool | operator<= (PBitwiseEnum rhs) const
__inline bool | operator>= (PBitwiseEnum rhs) const
__inline bool | operator!= (PBitwiseEnum rhs) const
__inline bool | operator< (PBitwiseEnum rhs) const
__inline bool | operator> (PBitwiseEnum rhs) const
__inline PBitwiseEnum | operator~ () const

## Friends
__inline std::ostream & | operator<< (std::ostream &strm, const PStreamableBitwiseEnum &e)
__inline std::istream & | operator>> (std::istream &strm, PStreamableBitwiseEnum &e)

## Additional Inherited Members
Static Public Member Functions inherited from PBitwiseEnum< BaseEnum, MaxValue, BaseInt >
static __inline Enumeration | Zero ()
static __inline Enumeration | FromBits (unsigned b)
static __inline Enumeration | FromBit (unsigned b)
Protected Attributes inherited from PBitwiseEnum< BaseEnum, MaxValue, BaseInt >
Enumeration | m_enum

## Member Typedef Documentation

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

typedef PBitwiseEnum<BaseEnum, MaxValue, BaseInt> PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::BaseClass

## Constructor & Destructor Documentation

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

__inline PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::PStreamableBitwiseEnum | ( | typename BaseClass::Enumeration | e = `BaseClass::Zero()` | ) |
| inline

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

__inline PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::PStreamableBitwiseEnum | ( | typename BaseClass::IteratorBounds | b | ) |
| inline

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

virtual __inline PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::~PStreamableBitwiseEnum | ( |  | ) |
| inline virtual

## Member Function Documentation

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

bool PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::FromString | ( | const PString & | s,
|  | bool | clear = `true`
| ) |  |
| inline

References PBitwiseEnum< BaseEnum, MaxValue, BaseInt >::FromBits(), PBitwiseEnum< BaseEnum, MaxValue, BaseInt >::m_enum, PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::Names(), PReadBitwiseEnum(), and PBitwiseEnum< BaseEnum, MaxValue, BaseInt >::Zero().

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

virtual char const* const* PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::Names | ( |  | ) | const
| pure virtual

Referenced by PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::FromString().

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

PString PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt >::ToString | ( |  | ) |
| inline

## Friends And Related Function Documentation

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

__inline std::ostream& operator<< | ( | std::ostream & | strm,
|  | const PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt > & | e
| ) |  |
| friend

template<typename BaseEnum , BaseEnum MaxValue, typename BaseInt = unsigned>

__inline std::istream& operator>> | ( | std::istream & | strm,
|  | PStreamableBitwiseEnum< BaseEnum, MaxValue, BaseInt > & | e
| ) |  |
| friend

The documentation for this class was generated from the following file:

- bitwise_enum.h